import 'dart:convert';

import 'package:path/path.dart' as path;
import 'dart:io';

Future<File> catchFile(String rootPath) async {
  File file = File(path.join(rootPath, "catch"));
  if (await file.exists()) {
    return file;
  } else {
    await file.create(recursive: false);
    return file;
  }
}

Future<Null> writeToCatchFile(String rootPath, Map<String, dynamic> catchMap) async {
  File file = await catchFile(rootPath);
  await file.writeAsString(jsonEncode(catchMap));
}
